Shortest Path HDU - 3631 最短路径(Floyd算法)

  • Shortest Path

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3631

When YY was a boy and LMY was a girl, they trained for NOI (National Olympiad in Informatics) in GD team. One day, GD team’s coach, Prof. GUO asked them to solve the following shortest-path problem. 
There is a weighted directed multigraph G. And there are following two operations for the weighted directed multigraph: 
(1) Mark a vertex in the graph. 
(2) Find the shortest-path between two vertices only through marked vertices. 
For it was the first time that LMY faced such a problem, she was very nervous. At this moment, YY decided to help LMY to analyze the shortest-path problem. With the help of YY, LMY solved the problem at once, admiring YY very much. Since then, when LMY meets problems, she always calls YY to analyze the problems for her. Of course, YY is very glad to help LMY. Finally, it is known to us all, YY and LMY become programming lovers. 
Could you also solve the shortest-path problem? 

Input

The input consists of multiple test cases. For each test case, the first line contains three integers N, M and Q, where N is the number of vertices in the given graph, N≤300; M is the number of arcs, M≤100000; and Q is the number of operations, Q ≤100000. All vertices are number as 0, 1, 2, … , N - 1, respectively. Initially all vertices are unmarked. Each of the next M lines describes an arc by three integers (x, y, c): initial vertex (x), terminal vertex (y), and the weight of the arc (c). (c > 0) Then each of the next Q lines describes an operation, where operation “0 x” represents that vertex x is marked, and operation “1 x y” finds the length of shortest-path between x and y only through marked vertices. There is a blank line between two consecutive test cases. 
End of input is indicated by a line containing N = M = Q = 0. 

Output

Start each test case with "Case #:" on a single line, where # is the case number starting from 1. 
For operation “0 x”, if vertex x has been marked, output “ERROR! At point x”. 
For operation “1 x y”, if vertex x or vertex y isn’t marked, output “ERROR! At path x to y”; if y isn’t reachable from x through marked vertices, output “No such path”; otherwise output the length of the shortest-path. The format is showed as sample output. 
There is a blank line between two consecutive test cases. 

Sample Input

5 10 10
1 2 6335
0 4 5725
3 3 6963
4 0 8146
1 2 9962
1 0 1943
2 1 2392
4 2 154
2 2 7422
1 3 9896
0 1
0 3
0 2
0 4
0 4
0 1
1 3 3
1 1 1
0 3
0 4
0 0 0

Sample Output

Case 1:
ERROR! At point 4
ERROR! At point 1
0
0
ERROR! At point 3
ERROR! At point 4

题意:有向图,有重边。选中一些点,在这些点里面求两点的最短路。有2个操作,操作 "0" 表示标记 x 选中,如果x之前已经被选中,输出 "ERROR! At point x"。操作 "1" 表示求 x ->y 的最短路,如果x或y不在选中的点里面,输出 "ERROR! At path x to y",否则,如果x->y不能通过已标记的点求出最短路,则输出 "No such path",否则输出最短路的值。每组样例“Case #:”之间用一空行隔开。

思路:一开始没看懂题,直接用Floyd算法先求最短路,然后再在每次询问中输出值,但是实际的题意是求经过标记点的最短路。由于每次询问求最短路都是和当前已经标记的点有关,所以需要在操作“0”更新标记点的时候将最短路也一起更新。

AC代码:

280ms

#include<iostream>
#include<cmath>
#include<cstring>
#include<string>
#include<algorithm>
#include<cstdio>
using namespace std;
const int INF = 0x3f3f3f3f;
const int MAXN = 1e5 + 7;
#define ll long long
int n, m;
int map[1010][1010];
int visit[1010];
int dist[1010][1010];
void Floyd(int k);
int main()
{
	int t;
	int k = 1;
	while (~scanf("%d%d%d",&n,&m,&t)) {
		if (n == 0 && m == 0 && t == 0)
			break;
		memset(visit, 0, sizeof(visit));
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; ++j) {
				if (i == j)
					dist[i][j] = 0;
				else
					dist[i][j] = INF;
			}
		}
		for (int i = 0; i < m; ++i) {
			int a, b, c;
			scanf("%d%d%d", &a, &b, &c);
			if (dist[a][b] > c)
				dist[a][b] = c;
		}
		if (k != 1)
			printf("\n");
		printf("Case %d:\n", k);
		for (int i = 1; i <= t; ++i) {
			int x,y,z;
			scanf("%d", &x);
			if (x == 0) {
				scanf("%d", &y);
				if (visit[y] == 0) {
					Floyd(y);
					visit[y] = 1;
				}
				else
					printf("ERROR! At point %d\n", y);
			}
			else if (x == 1) {
				scanf("%d%d", &y, &z);
				if (visit[z] == 0 || visit[y] == 0)
					printf("ERROR! At path %d to %d\n", y, z);
				else {
					if (dist[y][z] == INF)
						printf("No such path\n");
					else
						printf("%d\n", dist[y][z]);
				}
			}
		}
		k++;
	}
}

void Floyd(int k) {
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (dist[i][k] < INF&&dist[k][j] < INF) {
				dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
			}
		}
	}
}

猜你喜欢

转载自blog.csdn.net/weixin_43821265/article/details/86612311